Index: trunk/doc/Flair/search/functions_12.js
===================================================================
--- trunk/doc/Flair/search/functions_12.js	(revision 35)
+++ trunk/doc/Flair/search/functions_12.js	(revision 36)
@@ -444,5 +444,5 @@
   ['setcellwidget',['setCellWidget',['http://qt-project.org/doc/qt-4.8/qtablewidget.html#setCellWidget',0,'QTableWidget::setCellWidget()'],['http://qt-project.org/doc/qt-4.8/q3table.html#setCellWidget',0,'Q3Table::setCellWidget()']]],
   ['setcellwidth',['setCellWidth',['http://qt-project.org/doc/qt-4.8/q3gridview.html#cellWidth-prop',0,'Q3GridView']]],
-  ['setcenter',['SetCenter',['../classflair_1_1filter_1_1_trajectory_generator2_d_circle.html#a741d8a2f31ae41217e6a7aadcf2c1004',1,'flair::filter::TrajectoryGenerator2DCircle::SetCenter()'],['http://qt-project.org/doc/qt-4.8/qradialgradient.html#setCenter',0,'QRadialGradient::setCenter(const QPointF &amp;center)'],['http://qt-project.org/doc/qt-4.8/qradialgradient.html#setCenter-2',0,'QRadialGradient::setCenter(qreal x, qreal y)'],['http://qt-project.org/doc/qt-4.8/qconicalgradient.html#setCenter',0,'QConicalGradient::setCenter(const QPointF &amp;center)'],['http://qt-project.org/doc/qt-4.8/qconicalgradient.html#setCenter-2',0,'QConicalGradient::setCenter(qreal x, qreal y)']]],
+  ['setcenter',['setCenter',['http://qt-project.org/doc/qt-4.8/qradialgradient.html#setCenter',0,'QRadialGradient::setCenter(const QPointF &amp;center)'],['http://qt-project.org/doc/qt-4.8/qradialgradient.html#setCenter-2',0,'QRadialGradient::setCenter(qreal x, qreal y)'],['http://qt-project.org/doc/qt-4.8/qconicalgradient.html#setCenter',0,'QConicalGradient::setCenter(const QPointF &amp;center)'],['http://qt-project.org/doc/qt-4.8/qconicalgradient.html#setCenter-2',0,'QConicalGradient::setCenter(qreal x, qreal y)'],['../classflair_1_1filter_1_1_trajectory_generator2_d_circle.html#a741d8a2f31ae41217e6a7aadcf2c1004',1,'flair::filter::TrajectoryGenerator2DCircle::SetCenter()']]],
   ['setcenterbuttons',['setCenterButtons',['http://qt-project.org/doc/qt-4.8/qdialogbuttonbox.html#centerButtons-prop',0,'QDialogButtonBox']]],
   ['setcenterindicator',['setCenterIndicator',['http://qt-project.org/doc/qt-4.8/q3progressbar.html#centerIndicator-prop',0,'Q3ProgressBar']]],
@@ -749,5 +749,5 @@
   ['setelidemode',['setElideMode',['http://qt-project.org/doc/qt-4.8/qtabwidget.html#elideMode-prop',0,'QTabWidget::setElideMode()'],['http://qt-project.org/doc/qt-4.8/qtabbar.html#elideMode-prop',0,'QTabBar::setElideMode()']]],
   ['setemptylabel',['setEmptyLabel',['http://qt-project.org/doc/qt-4.8/qundoview.html#emptyLabel-prop',0,'QUndoView']]],
-  ['setenabled',['setEnabled',['http://qt-project.org/doc/qt-4.8/qwidget.html#enabled-prop',0,'QWidget::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3accel.html#setEnabled',0,'Q3Accel::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qshortcut.html#enabled-prop',0,'QShortcut::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3listviewitem.html#setEnabled',0,'Q3ListViewItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3combobox.html#setEnabled',0,'Q3ComboBox::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qstandarditem.html#setEnabled',0,'QStandardItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qlayout.html#setEnabled',0,'QLayout::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qaction.html#enabled-prop',0,'QAction::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3tableitem.html#setEnabled',0,'Q3TableItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qsocketnotifier.html#setEnabled',0,'QSocketNotifier::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qgraphicsitem.html#setEnabled',0,'QGraphicsItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qactiongroup.html#enabled-prop',0,'QActionGroup::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3action.html#enabled-prop',0,'Q3Action::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3actiongroup.html#setEnabled',0,'Q3ActionGroup::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qgraphicseffect.html#enabled-prop',0,'QGraphicsEffect::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3canvasitem.html#setEnabled',0,'Q3CanvasItem::setEnabled()'],['../classflair_1_1gui_1_1_widget.html#a814a933622114ad9c8f5d49014262d89',1,'flair::gui::Widget::setEnabled()'],['../classflair_1_1actuator_1_1_bldc.html#ac030794b46b72db4184592f7cff11731',1,'flair::actuator::Bldc::SetEnabled()']]],
+  ['setenabled',['SetEnabled',['../classflair_1_1actuator_1_1_bldc.html#ac030794b46b72db4184592f7cff11731',1,'flair::actuator::Bldc::SetEnabled()'],['http://qt-project.org/doc/qt-4.8/qwidget.html#enabled-prop',0,'QWidget::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3accel.html#setEnabled',0,'Q3Accel::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qshortcut.html#enabled-prop',0,'QShortcut::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3listviewitem.html#setEnabled',0,'Q3ListViewItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3combobox.html#setEnabled',0,'Q3ComboBox::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qstandarditem.html#setEnabled',0,'QStandardItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qlayout.html#setEnabled',0,'QLayout::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qaction.html#enabled-prop',0,'QAction::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3tableitem.html#setEnabled',0,'Q3TableItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qsocketnotifier.html#setEnabled',0,'QSocketNotifier::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qgraphicsitem.html#setEnabled',0,'QGraphicsItem::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qactiongroup.html#enabled-prop',0,'QActionGroup::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3action.html#enabled-prop',0,'Q3Action::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3actiongroup.html#setEnabled',0,'Q3ActionGroup::setEnabled()'],['http://qt-project.org/doc/qt-4.8/qgraphicseffect.html#enabled-prop',0,'QGraphicsEffect::setEnabled()'],['http://qt-project.org/doc/qt-4.8/q3canvasitem.html#setEnabled',0,'Q3CanvasItem::setEnabled()'],['../classflair_1_1gui_1_1_widget.html#a814a933622114ad9c8f5d49014262d89',1,'flair::gui::Widget::setEnabled()']]],
   ['setenabledoptions',['setEnabledOptions',['http://qt-project.org/doc/qt-4.8/qabstractprintdialog-obsolete.html#setEnabledOptions',0,'QAbstractPrintDialog::setEnabledOptions()'],['http://qt-project.org/doc/qt-4.8/qpagesetupdialog-obsolete.html#setEnabledOptions',0,'QPageSetupDialog::setEnabledOptions()']]],
   ['setencodeddata',['setEncodedData',['http://qt-project.org/doc/qt-4.8/q3storeddrag.html#setEncodedData',0,'Q3StoredDrag']]],
@@ -1469,5 +1469,5 @@
   ['setradiobuttonexclusive',['setRadioButtonExclusive',['http://qt-project.org/doc/qt-4.8/q3buttongroup.html#radioButtonExclusive-prop',0,'Q3ButtonGroup']]],
   ['setradius',['setRadius',['http://qt-project.org/doc/qt-4.8/qradialgradient.html#setRadius',0,'QRadialGradient']]],
-  ['setrange',['setRange',['http://qt-project.org/doc/qt-4.8/q3dateedit.html#setRange',0,'Q3DateEdit::setRange()'],['http://qt-project.org/doc/qt-4.8/q3timeedit.html#setRange',0,'Q3TimeEdit::setRange()'],['http://qt-project.org/doc/qt-4.8/qspinbox.html#setRange',0,'QSpinBox::setRange()'],['http://qt-project.org/doc/qt-4.8/qdoublespinbox.html#setRange',0,'QDoubleSpinBox::setRange()'],['http://qt-project.org/doc/qt-4.8/qprogressbar.html#setRange',0,'QProgressBar::setRange()'],['http://qt-project.org/doc/qt-4.8/q3rangecontrol.html#setRange',0,'Q3RangeControl::setRange()'],['http://qt-project.org/doc/qt-4.8/qabstractslider.html#setRange',0,'QAbstractSlider::setRange()'],['http://qt-project.org/doc/qt-4.8/qintvalidator.html#setRange',0,'QIntValidator::setRange()'],['http://qt-project.org/doc/qt-4.8/qdoublevalidator.html#setRange',0,'QDoubleValidator::setRange()'],['http://qt-project.org/doc/qt-4.8/qprogressdialog.html#setRange',0,'QProgressDialog::setRange()'],['../classflair_1_1sensor_1_1_srf08.html#ae760771d1ec4ede8ec0a901c5e178b32',1,'flair::sensor::Srf08::SetRange()']]],
+  ['setrange',['SetRange',['../classflair_1_1sensor_1_1_srf08.html#ae760771d1ec4ede8ec0a901c5e178b32',1,'flair::sensor::Srf08::SetRange()'],['http://qt-project.org/doc/qt-4.8/q3dateedit.html#setRange',0,'Q3DateEdit::setRange()'],['http://qt-project.org/doc/qt-4.8/q3timeedit.html#setRange',0,'Q3TimeEdit::setRange()'],['http://qt-project.org/doc/qt-4.8/qspinbox.html#setRange',0,'QSpinBox::setRange()'],['http://qt-project.org/doc/qt-4.8/qdoublespinbox.html#setRange',0,'QDoubleSpinBox::setRange()'],['http://qt-project.org/doc/qt-4.8/qprogressbar.html#setRange',0,'QProgressBar::setRange()'],['http://qt-project.org/doc/qt-4.8/q3rangecontrol.html#setRange',0,'Q3RangeControl::setRange()'],['http://qt-project.org/doc/qt-4.8/qabstractslider.html#setRange',0,'QAbstractSlider::setRange()'],['http://qt-project.org/doc/qt-4.8/qintvalidator.html#setRange',0,'QIntValidator::setRange()'],['http://qt-project.org/doc/qt-4.8/qdoublevalidator.html#setRange',0,'QDoubleValidator::setRange()'],['http://qt-project.org/doc/qt-4.8/qprogressdialog.html#setRange',0,'QProgressDialog::setRange()']]],
   ['setrangeselected',['setRangeSelected',['http://qt-project.org/doc/qt-4.8/qtablewidget.html#setRangeSelected',0,'QTableWidget']]],
   ['setrawacc',['SetRawAcc',['../classflair_1_1core_1_1_imu_data.html#a97986291314f4ee0f665b8f8bf7ab056',1,'flair::core::ImuData']]],
@@ -1929,5 +1929,5 @@
   ['setvbargeometry',['setVBarGeometry',['http://qt-project.org/doc/qt-4.8/q3scrollview.html#setVBarGeometry',0,'Q3ScrollView']]],
   ['setvector',['setVector',['http://qt-project.org/doc/qt-4.8/qquaternion.html#setVector',0,'QQuaternion::setVector(const QVector3D &amp;vector)'],['http://qt-project.org/doc/qt-4.8/qquaternion.html#setVector-2',0,'QQuaternion::setVector(qreal x, qreal y, qreal z)']]],
-  ['setvelocity',['SetVelocity',['../classflair_1_1core_1_1_gps_data.html#a09134eda9e9abd781fd5a9193b2dbc58',1,'flair::core::GpsData::SetVelocity()'],['http://qt-project.org/doc/qt-4.8/q3canvasitem.html#setVelocity',0,'Q3CanvasItem::setVelocity()']]],
+  ['setvelocity',['setVelocity',['http://qt-project.org/doc/qt-4.8/q3canvasitem.html#setVelocity',0,'Q3CanvasItem::setVelocity()'],['../classflair_1_1core_1_1_gps_data.html#a09134eda9e9abd781fd5a9193b2dbc58',1,'flair::core::GpsData::SetVelocity()']]],
   ['setverdata',['setVerData',['http://qt-project.org/doc/qt-4.8/qsizepolicy-qt3.html#setVerData',0,'QSizePolicy']]],
   ['setversion',['setVersion',['http://qt-project.org/doc/qt-4.8/qdatastream.html#setVersion',0,'QDataStream::setVersion()'],['http://qt-project.org/doc/qt-4.8/qglformat.html#setVersion',0,'QGLFormat::setVersion()']]],
@@ -2149,5 +2149,5 @@
   ['smoothsizes',['smoothSizes',['http://qt-project.org/doc/qt-4.8/qfontdatabase.html#smoothSizes',0,'QFontDatabase']]],
   ['snapshot',['snapshot',['http://qt-project.org/doc/qt-4.8/phonon-videowidget.html#snapshot',0,'Phonon::VideoWidget::snapshot()'],['http://qt-project.org/doc/qt-4.8/phonon-videowidgetinterface44.html#snapshot',0,'Phonon::VideoWidgetInterface44::snapshot()']]],
-  ['socket',['Socket',['../classflair_1_1core_1_1_socket.html#aca27bc21b18df08ae8282181f6492313',1,'flair::core::Socket::Socket(const Object *parent, std::string name, std::string address, bool broadcast=false)'],['../classflair_1_1core_1_1_socket.html#af06b25a783310b900c52bafeb99d7813',1,'flair::core::Socket::Socket(const Object *parent, std::string name, uint16_t port)'],['http://qt-project.org/doc/qt-4.8/qsocketnotifier.html#socket',0,'QSocketNotifier::socket()'],['http://qt-project.org/doc/qt-4.8/qabstractsocket-qt3.html#socket',0,'QAbstractSocket::socket()'],['http://qt-project.org/doc/qt-4.8/q3socket.html#socket',0,'Q3Socket::socket()'],['http://qt-project.org/doc/qt-4.8/q3serversocket.html#socket',0,'Q3ServerSocket::socket()'],['http://qt-project.org/doc/qt-4.8/q3socketdevice.html#socket',0,'Q3SocketDevice::socket()']]],
+  ['socket',['socket',['http://qt-project.org/doc/qt-4.8/qsocketnotifier.html#socket',0,'QSocketNotifier::socket()'],['http://qt-project.org/doc/qt-4.8/qabstractsocket-qt3.html#socket',0,'QAbstractSocket::socket()'],['http://qt-project.org/doc/qt-4.8/q3socket.html#socket',0,'Q3Socket::socket()'],['http://qt-project.org/doc/qt-4.8/q3serversocket.html#socket',0,'Q3ServerSocket::socket()'],['http://qt-project.org/doc/qt-4.8/q3socketdevice.html#socket',0,'Q3SocketDevice::socket()'],['../classflair_1_1core_1_1_socket.html#aca27bc21b18df08ae8282181f6492313',1,'flair::core::Socket::Socket(const Object *parent, std::string name, std::string address, bool broadcast=false)'],['../classflair_1_1core_1_1_socket.html#af06b25a783310b900c52bafeb99d7813',1,'flair::core::Socket::Socket(const Object *parent, std::string name, uint16_t port)']]],
   ['socketdescriptor',['socketDescriptor',['http://qt-project.org/doc/qt-4.8/qlocalsocket.html#socketDescriptor',0,'QLocalSocket::socketDescriptor()'],['http://qt-project.org/doc/qt-4.8/qtcpserver.html#socketDescriptor',0,'QTcpServer::socketDescriptor()'],['http://qt-project.org/doc/qt-4.8/qabstractsocket.html#socketDescriptor',0,'QAbstractSocket::socketDescriptor()']]],
   ['socketdevice',['socketDevice',['http://qt-project.org/doc/qt-4.8/q3socket.html#socketDevice',0,'Q3Socket::socketDevice()'],['http://qt-project.org/doc/qt-4.8/q3serversocket.html#socketDevice',0,'Q3ServerSocket::socketDevice()']]],
@@ -2229,5 +2229,5 @@
   ['standardsizes',['standardSizes',['http://qt-project.org/doc/qt-4.8/qfontdatabase.html#standardSizes',0,'QFontDatabase']]],
   ['standardwindow',['standardWindow',['http://qt-project.org/doc/qt-4.8/qscriptenginedebugger.html#standardWindow',0,'QScriptEngineDebugger']]],
-  ['start',['start',['http://qt-project.org/doc/qt-4.8/qprocess.html#start',0,'QProcess::start(const QString &amp;program, const QStringList &amp;arguments, QFlags&lt; QIODevice::OpenModeFlag &gt; mode)'],['http://qt-project.org/doc/qt-4.8/qprocess.html#start-2',0,'QProcess::start(const QString &amp;program, QFlags&lt; QIODevice::OpenModeFlag &gt; mode)'],['http://qt-project.org/doc/qt-4.8/qthreadpool.html#start',0,'QThreadPool::start()'],['http://qt-project.org/doc/qt-4.8/qdrag-obsolete.html#start',0,'QDrag::start()'],['http://qt-project.org/doc/qt-4.8/q3urloperator.html#start',0,'Q3UrlOperator::start()'],['http://qt-project.org/doc/qt-4.8/qbasictimer.html#start',0,'QBasicTimer::start()'],['http://qt-project.org/doc/qt-4.8/q3process.html#start',0,'Q3Process::start()'],['http://qt-project.org/doc/qt-4.8/q3networkprotocol.html#start',0,'Q3NetworkProtocol::start()'],['http://qt-project.org/doc/qt-4.8/qtime.html#start',0,'QTime::start()'],['http://qt-project.org/doc/qt-4.8/qabstractanimation.html#start',0,'QAbstractAnimation::start()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#start',0,'QAudioInput::start(QIODevice *device)'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#start-2',0,'QAudioInput::start()'],['http://qt-project.org/doc/qt-4.8/qtimeline.html#start',0,'QTimeLine::start()'],['http://qt-project.org/doc/qt-4.8/qstatemachine.html#start',0,'QStateMachine::start()'],['http://qt-project.org/doc/qt-4.8/qlineargradient.html#start',0,'QLinearGradient::start()'],['http://qt-project.org/doc/qt-4.8/qthread.html#start',0,'QThread::start()'],['http://qt-project.org/doc/qt-4.8/qtimer.html#start',0,'QTimer::start(int msec)'],['http://qt-project.org/doc/qt-4.8/qtimer.html#start-2',0,'QTimer::start()'],['http://qt-project.org/doc/qt-4.8/qtimer-qt3.html#start-3',0,'QTimer::start(int msec, bool sshot)'],['http://qt-project.org/doc/qt-4.8/qabstractvideosurface.html#start',0,'QAbstractVideoSurface::start()'],['http://qt-project.org/doc/qt-4.8/qelapsedtimer.html#start',0,'QElapsedTimer::start()'],['http://qt-project.org/doc/qt-4.8/qmovie.html#start',0,'QMovie::start()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#start',0,'QAudioOutput::start(QIODevice *device)'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#start-2',0,'QAudioOutput::start()'],['../classflair_1_1filter_1_1_gx3__25__ahrs.html#ad91254adabea1141dd3bdb2ff4ad1462',1,'flair::filter::Gx3_25_ahrs::Start()'],['../classflair_1_1filter_1_1_simu_ahrs.html#a62d4c34069a45aa85acb5d16c0ecccc2',1,'flair::filter::SimuAhrs::Start()'],['../classflair_1_1core_1_1_thread.html#a5a4f0f27689ae4292f81bf45e22998a5',1,'flair::core::Thread::Start()']]],
+  ['start',['Start',['../classflair_1_1filter_1_1_gx3__25__ahrs.html#ad91254adabea1141dd3bdb2ff4ad1462',1,'flair::filter::Gx3_25_ahrs::Start()'],['../classflair_1_1filter_1_1_simu_ahrs.html#a62d4c34069a45aa85acb5d16c0ecccc2',1,'flair::filter::SimuAhrs::Start()'],['../classflair_1_1core_1_1_thread.html#a5a4f0f27689ae4292f81bf45e22998a5',1,'flair::core::Thread::Start()'],['http://qt-project.org/doc/qt-4.8/qprocess.html#start',0,'QProcess::start(const QString &amp;program, const QStringList &amp;arguments, QFlags&lt; QIODevice::OpenModeFlag &gt; mode)'],['http://qt-project.org/doc/qt-4.8/qprocess.html#start-2',0,'QProcess::start(const QString &amp;program, QFlags&lt; QIODevice::OpenModeFlag &gt; mode)'],['http://qt-project.org/doc/qt-4.8/qthreadpool.html#start',0,'QThreadPool::start()'],['http://qt-project.org/doc/qt-4.8/qdrag-obsolete.html#start',0,'QDrag::start()'],['http://qt-project.org/doc/qt-4.8/q3urloperator.html#start',0,'Q3UrlOperator::start()'],['http://qt-project.org/doc/qt-4.8/qbasictimer.html#start',0,'QBasicTimer::start()'],['http://qt-project.org/doc/qt-4.8/q3process.html#start',0,'Q3Process::start()'],['http://qt-project.org/doc/qt-4.8/q3networkprotocol.html#start',0,'Q3NetworkProtocol::start()'],['http://qt-project.org/doc/qt-4.8/qtime.html#start',0,'QTime::start()'],['http://qt-project.org/doc/qt-4.8/qabstractanimation.html#start',0,'QAbstractAnimation::start()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#start',0,'QAudioInput::start(QIODevice *device)'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#start-2',0,'QAudioInput::start()'],['http://qt-project.org/doc/qt-4.8/qtimeline.html#start',0,'QTimeLine::start()'],['http://qt-project.org/doc/qt-4.8/qstatemachine.html#start',0,'QStateMachine::start()'],['http://qt-project.org/doc/qt-4.8/qlineargradient.html#start',0,'QLinearGradient::start()'],['http://qt-project.org/doc/qt-4.8/qthread.html#start',0,'QThread::start()'],['http://qt-project.org/doc/qt-4.8/qtimer.html#start',0,'QTimer::start(int msec)'],['http://qt-project.org/doc/qt-4.8/qtimer.html#start-2',0,'QTimer::start()'],['http://qt-project.org/doc/qt-4.8/qtimer-qt3.html#start-3',0,'QTimer::start(int msec, bool sshot)'],['http://qt-project.org/doc/qt-4.8/qabstractvideosurface.html#start',0,'QAbstractVideoSurface::start()'],['http://qt-project.org/doc/qt-4.8/qelapsedtimer.html#start',0,'QElapsedTimer::start()'],['http://qt-project.org/doc/qt-4.8/qmovie.html#start',0,'QMovie::start()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#start',0,'QAudioOutput::start(QIODevice *device)'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#start-2',0,'QAudioOutput::start()']]],
   ['startangle',['startAngle',['http://qt-project.org/doc/qt-4.8/qgraphicsellipseitem.html#startAngle',0,'QGraphicsEllipseItem']]],
   ['startcdata',['startCDATA',['http://qt-project.org/doc/qt-4.8/qxmllexicalhandler.html#startCDATA',0,'QXmlLexicalHandler::startCDATA()'],['http://qt-project.org/doc/qt-4.8/qxmldefaulthandler.html#startCDATA',0,'QXmlDefaultHandler::startCDATA()']]],
@@ -2267,5 +2267,5 @@
   ['starttraj',['StartTraj',['../classflair_1_1filter_1_1_trajectory_generator1_d.html#ab682c3574b7a050bd65475ce00d03a16',1,'flair::filter::TrajectoryGenerator1D::StartTraj()'],['../classflair_1_1filter_1_1_trajectory_generator2_d_circle.html#a5789f6cf4829447a33fc672261ab16ae',1,'flair::filter::TrajectoryGenerator2DCircle::StartTraj()']]],
   ['startvalue',['startValue',['http://qt-project.org/doc/qt-4.8/qvariantanimation.html#startValue-prop',0,'QVariantAnimation']]],
-  ['state',['State',['../classflair_1_1sensor_1_1_vrpn_object.html#acb5162ae1ed3ea0b646ab12ac6879279',1,'flair::sensor::VrpnObject::State()'],['http://qt-project.org/doc/qt-4.8/qnetworksession.html#state',0,'QNetworkSession::state()'],['http://qt-project.org/doc/qt-4.8/phonon-mediaobject.html#state',0,'Phonon::MediaObject::state()'],['http://qt-project.org/doc/qt-4.8/q3http.html#state',0,'Q3Http::state()'],['http://qt-project.org/doc/qt-4.8/qiodevice-qt3.html#state',0,'QIODevice::state()'],['http://qt-project.org/doc/qt-4.8/qgesture.html#state-prop',0,'QGesture::state()'],['http://qt-project.org/doc/qt-4.8/qaxscriptengine.html#state',0,'QAxScriptEngine::state()'],['http://qt-project.org/doc/qt-4.8/qhttp.html#state',0,'QHttp::state()'],['http://qt-project.org/doc/qt-4.8/qaccessibleinterface.html#state',0,'QAccessibleInterface::state()'],['http://qt-project.org/doc/qt-4.8/qscriptsyntaxcheckresult.html#state',0,'QScriptSyntaxCheckResult::state()'],['http://qt-project.org/doc/qt-4.8/qprocess.html#state',0,'QProcess::state()'],['http://qt-project.org/doc/qt-4.8/qlocalsocket.html#state',0,'QLocalSocket::state()'],['http://qt-project.org/doc/qt-4.8/qnetworkconfiguration.html#state',0,'QNetworkConfiguration::state()'],['http://qt-project.org/doc/qt-4.8/qscriptcontext.html#state',0,'QScriptContext::state()'],['http://qt-project.org/doc/qt-4.8/q3checklistitem.html#state',0,'Q3CheckListItem::state()'],['http://qt-project.org/doc/qt-4.8/qscriptenginedebugger.html#state',0,'QScriptEngineDebugger::state()'],['http://qt-project.org/doc/qt-4.8/qcheckbox-qt3.html#state',0,'QCheckBox::state()'],['http://qt-project.org/doc/qt-4.8/qabstractitemview.html#state',0,'QAbstractItemView::state()'],['http://qt-project.org/doc/qt-4.8/qmouseevent-qt3.html#state',0,'QMouseEvent::state()'],['http://qt-project.org/doc/qt-4.8/qwheelevent-qt3.html#state',0,'QWheelEvent::state()'],['http://qt-project.org/doc/qt-4.8/qkeyevent-qt3.html#state',0,'QKeyEvent::state()'],['http://qt-project.org/doc/qt-4.8/qcontextmenuevent-qt3.html#state',0,'QContextMenuEvent::state()'],['http://qt-project.org/doc/qt-4.8/qtouchevent-touchpoint.html#state',0,'QTouchEvent::TouchPoint::state()'],['http://qt-project.org/doc/qt-4.8/q3networkoperation.html#state',0,'Q3NetworkOperation::state()'],['http://qt-project.org/doc/qt-4.8/qaccessiblewidget.html#state',0,'QAccessibleWidget::state()'],['http://qt-project.org/doc/qt-4.8/qpaintenginestate.html#state',0,'QPaintEngineState::state()'],['http://qt-project.org/doc/qt-4.8/qabstractanimation.html#state-prop',0,'QAbstractAnimation::state()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#state',0,'QAudioInput::state()'],['http://qt-project.org/doc/qt-4.8/qabstractsocket.html#state',0,'QAbstractSocket::state()'],['http://qt-project.org/doc/qt-4.8/qtimeline.html#state',0,'QTimeLine::state()'],['http://qt-project.org/doc/qt-4.8/q3ftp.html#state',0,'Q3Ftp::state()'],['http://qt-project.org/doc/qt-4.8/qftp.html#state',0,'QFtp::state()'],['http://qt-project.org/doc/qt-4.8/q3socket.html#state',0,'Q3Socket::state()'],['http://qt-project.org/doc/qt-4.8/qmovie.html#state',0,'QMovie::state()'],['http://qt-project.org/doc/qt-4.8/qwswindow.html#state',0,'QWSWindow::state()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#state',0,'QAudioOutput::state()']]],
+  ['state',['state',['http://qt-project.org/doc/qt-4.8/qnetworksession.html#state',0,'QNetworkSession::state()'],['http://qt-project.org/doc/qt-4.8/phonon-mediaobject.html#state',0,'Phonon::MediaObject::state()'],['http://qt-project.org/doc/qt-4.8/q3http.html#state',0,'Q3Http::state()'],['http://qt-project.org/doc/qt-4.8/qiodevice-qt3.html#state',0,'QIODevice::state()'],['http://qt-project.org/doc/qt-4.8/qgesture.html#state-prop',0,'QGesture::state()'],['http://qt-project.org/doc/qt-4.8/qaxscriptengine.html#state',0,'QAxScriptEngine::state()'],['http://qt-project.org/doc/qt-4.8/qhttp.html#state',0,'QHttp::state()'],['http://qt-project.org/doc/qt-4.8/qaccessibleinterface.html#state',0,'QAccessibleInterface::state()'],['http://qt-project.org/doc/qt-4.8/qscriptsyntaxcheckresult.html#state',0,'QScriptSyntaxCheckResult::state()'],['http://qt-project.org/doc/qt-4.8/qprocess.html#state',0,'QProcess::state()'],['http://qt-project.org/doc/qt-4.8/qlocalsocket.html#state',0,'QLocalSocket::state()'],['http://qt-project.org/doc/qt-4.8/qnetworkconfiguration.html#state',0,'QNetworkConfiguration::state()'],['http://qt-project.org/doc/qt-4.8/qscriptcontext.html#state',0,'QScriptContext::state()'],['http://qt-project.org/doc/qt-4.8/q3checklistitem.html#state',0,'Q3CheckListItem::state()'],['http://qt-project.org/doc/qt-4.8/qscriptenginedebugger.html#state',0,'QScriptEngineDebugger::state()'],['http://qt-project.org/doc/qt-4.8/qcheckbox-qt3.html#state',0,'QCheckBox::state()'],['http://qt-project.org/doc/qt-4.8/qabstractitemview.html#state',0,'QAbstractItemView::state()'],['http://qt-project.org/doc/qt-4.8/qmouseevent-qt3.html#state',0,'QMouseEvent::state()'],['http://qt-project.org/doc/qt-4.8/qwheelevent-qt3.html#state',0,'QWheelEvent::state()'],['http://qt-project.org/doc/qt-4.8/qkeyevent-qt3.html#state',0,'QKeyEvent::state()'],['http://qt-project.org/doc/qt-4.8/qcontextmenuevent-qt3.html#state',0,'QContextMenuEvent::state()'],['http://qt-project.org/doc/qt-4.8/qtouchevent-touchpoint.html#state',0,'QTouchEvent::TouchPoint::state()'],['http://qt-project.org/doc/qt-4.8/q3networkoperation.html#state',0,'Q3NetworkOperation::state()'],['http://qt-project.org/doc/qt-4.8/qaccessiblewidget.html#state',0,'QAccessibleWidget::state()'],['http://qt-project.org/doc/qt-4.8/qpaintenginestate.html#state',0,'QPaintEngineState::state()'],['http://qt-project.org/doc/qt-4.8/qabstractanimation.html#state-prop',0,'QAbstractAnimation::state()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#state',0,'QAudioInput::state()'],['http://qt-project.org/doc/qt-4.8/qabstractsocket.html#state',0,'QAbstractSocket::state()'],['http://qt-project.org/doc/qt-4.8/qtimeline.html#state',0,'QTimeLine::state()'],['http://qt-project.org/doc/qt-4.8/q3ftp.html#state',0,'Q3Ftp::state()'],['http://qt-project.org/doc/qt-4.8/qftp.html#state',0,'QFtp::state()'],['http://qt-project.org/doc/qt-4.8/q3socket.html#state',0,'Q3Socket::state()'],['http://qt-project.org/doc/qt-4.8/qmovie.html#state',0,'QMovie::state()'],['http://qt-project.org/doc/qt-4.8/qwswindow.html#state',0,'QWSWindow::state()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#state',0,'QAudioOutput::state()'],['../classflair_1_1sensor_1_1_vrpn_object.html#acb5162ae1ed3ea0b646ab12ac6879279',1,'flair::sensor::VrpnObject::State()']]],
   ['stateafter',['stateAfter',['http://qt-project.org/doc/qt-4.8/qmouseevent-qt3.html#stateAfter',0,'QMouseEvent::stateAfter()'],['http://qt-project.org/doc/qt-4.8/qkeyevent-qt3.html#stateAfter',0,'QKeyEvent::stateAfter()']]],
   ['statechange',['stateChange',['http://qt-project.org/doc/qt-4.8/q3checklistitem.html#stateChange',0,'Q3CheckListItem']]],
@@ -2398,5 +2398,5 @@
   ['surfaceformatchanged',['surfaceFormatChanged',['http://qt-project.org/doc/qt-4.8/qabstractvideosurface.html#surfaceFormatChanged',0,'QAbstractVideoSurface']]],
   ['surrogatetoucs4',['surrogateToUcs4',['http://qt-project.org/doc/qt-4.8/qchar.html#surrogateToUcs4',0,'QChar::surrogateToUcs4(ushort high, ushort low)'],['http://qt-project.org/doc/qt-4.8/qchar.html#surrogateToUcs4-2',0,'QChar::surrogateToUcs4(QChar high, QChar low)']]],
-  ['suspend',['Suspend',['../classflair_1_1core_1_1_thread.html#a0e5fc8919ed6042e5736a5dca5ba546b',1,'flair::core::Thread::Suspend()'],['http://qt-project.org/doc/qt-4.8/qwsmousehandler.html#suspend',0,'QWSMouseHandler::suspend()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#suspend',0,'QAudioInput::suspend()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#suspend',0,'QAudioOutput::suspend()']]],
+  ['suspend',['suspend',['http://qt-project.org/doc/qt-4.8/qwsmousehandler.html#suspend',0,'QWSMouseHandler::suspend()'],['http://qt-project.org/doc/qt-4.8/qaudioinput.html#suspend',0,'QAudioInput::suspend()'],['http://qt-project.org/doc/qt-4.8/qaudiooutput.html#suspend',0,'QAudioOutput::suspend()'],['../classflair_1_1core_1_1_thread.html#a0e5fc8919ed6042e5736a5dca5ba546b',1,'flair::core::Thread::Suspend()']]],
   ['suspendmouse',['suspendMouse',['http://qt-project.org/doc/qt-4.8/qwsserver.html#suspendMouse',0,'QWSServer']]],
   ['suspenduntil',['SuspendUntil',['../classflair_1_1core_1_1_thread.html#af93c2461c31a6c16958bc44189ab4253',1,'flair::core::Thread']]],